/*
 * for special system call by special patch to QEMU
 */

#define SPECIAL_SYSCALL_READC  1
#define SPECIAL_SYSCALL_WRITEC 2
#define SPECIAL_SYSCALL_EXIT   (0x80 + 1)
#define SPECIAL_SYSCALL_OPEN   (0x80 + 3)
#define SPECIAL_SYSCALL_READ   (0x80 + 4)
#define SPECIAL_SYSCALL_WRITE  (0x80 + 5)
#define SPECIAL_SYSCALL_CLOSE  (0x80 + 6)

/*
 * for semihosting call on QEMU
 */

#define SWI_SEMIHOSTING  0x123456
#define SEMIHOSTING_OPEN  0x01
#define SEMIHOSTING_CLOSE 0x02
#define SEMIHOSTING_WRITE 0x05
#define SEMIHOSTING_READ  0x06
#define SEMIHOSTING_EXIT  0x18

	.org	0x46e0

	.section .text

	.globl	_start
	.type	_start, %function
_start:
_fname:	.string	"word.txt"
	.byte	0
	.byte	0
	.byte	0
	.long	0

	.long	0	/* FP -> new FP */
	.long	1f	/* IP -> new SP */
	.long	1f	/* LR -> new PC */
	.long	0	/* PC -> discard */

1:	sub	sp, sp, #32

	ldr	r0, _fname_addr
	mov	r1, #0
	mov	r2, #0

	.globl	__semihosting_open
	.type	__semihosting_open, %function
__semihosting_open:
	push	{ r0, r1, r2, r3 }
	ldr	r0, _semihosting_sys_open
	mov	r1, sp
	swi	SWI_SEMIHOSTING
	mov	r4, r0

	mov	r0, r4
	ldr	r1, _buffer_addr
	mov	r2, #64

	.globl	__semihosting_read
	.type	__semihosting_read, %function
__semihosting_read:
	push	{ r0, r1, r2, r3 }
	ldr	r0, _semihosting_sys_read
	mov	r1, sp
	swi	SWI_SEMIHOSTING
	mov	r5, r0

	mov	r0, #1
	ldr	r1, _buffer_addr
	mov	r2, r5

	.globl	__semihosting_write
	.type	__semihosting_write, %function
__semihosting_write:
	push	{ r0, r1, r2, r3 }
	ldr	r0, _semihosting_sys_write
	mov	r1, sp
	swi	SWI_SEMIHOSTING

	mov	r0, r4

	.globl	__semihosting_close
	.type	__semihosting_close, %function
__semihosting_close:
	push	{ r0, r1, r2, r3 }
	ldr	r0, _semihosting_sys_close
	mov	r1, sp
	swi	SWI_SEMIHOSTING

	mov	r0, #0

	.globl	__semihosting_exit
	.type	__semihosting_exit, %function
__semihosting_exit:
	push	{ r0, r1, r2, r3 }
	ldr	r0, _semihosting_sys_exit
	mov	r1, sp
	swi	SWI_SEMIHOSTING

1:	b	1b

	.align 4
_semihosting_sys_open:
	.long	SEMIHOSTING_OPEN
_semihosting_sys_close:
	.long	SEMIHOSTING_CLOSE
_semihosting_sys_write:
	.long	SEMIHOSTING_WRITE
_semihosting_sys_read:
	.long	SEMIHOSTING_READ
_semihosting_sys_exit:
	.long	SEMIHOSTING_EXIT

	.align 4
_fname_addr:
	.long	_fname
_buffer_addr:
	.long	_buffer
_buffer:
