/*
 * for special system call by special patch to QEMU
 */

#define SPECIAL_SYSCALL_READC  1
#define SPECIAL_SYSCALL_WRITEC 2
#define SPECIAL_SYSCALL_EXIT   (0x80 + 1)
#define SPECIAL_SYSCALL_OPEN   (0x80 + 3)
#define SPECIAL_SYSCALL_READ   (0x80 + 4)
#define SPECIAL_SYSCALL_WRITE  (0x80 + 5)
#define SPECIAL_SYSCALL_CLOSE  (0x80 + 6)

/*
 * for semihosting call on QEMU
 */

#define SEMIHOSTING_EXIT  1
#define SEMIHOSTING_OPEN  2
#define SEMIHOSTING_CLOSE 3
#define SEMIHOSTING_READ  4
#define SEMIHOSTING_WRITE 5

#if 0
	.org	0x800006e0
#else
	.org	0x000006e0
#endif

	.section .text

	.globl	_start
	.type	_start, @function
_start:
_fname:	.string	"flag.txt"
	.byte	0
	.byte	0
	.byte	0
	.long	0

	.long	0
	.long	(1f + 0x80000000)	/* RA */

1:	addiu	$sp, $sp, -24

	lui	$a0, %hi(_fname)
	addiu	$a0, $a0, %lo(_fname)
	lui	$v0, 0x8000
	or	$a0, $a0, $v0
	li	$a1, (0x020a - 1)
	addiu	$a1, $a1, 1	/* make 0x020a, but avoid 0x0a('\n') */
	li	$a2, 0

	.globl	__semihosting_open
	.type	__semihosting_open, @function
__semihosting_open:
	li	$t9, SEMIHOSTING_OPEN
	sdbbp	1
	move	$s0, $v0

	lui	$a1, %hi(_buffer)
	addiu	$a1, $a1, %lo(_buffer)
	lui	$v0, 0x8000
	or	$a1, $a1, $v0
	li	$a0, ('\n' - 1)
	addiu	$a0, $a0, 1	/* make '\n', but avoid 0x0a('\n') */
	sb	$a0, 31($a1)

	move	$a0, $s0
	li	$a2, 32

	.globl	__semihosting_write
	.type	__semihosting_write, @function
__semihosting_write:
	li	$t9, SEMIHOSTING_WRITE
	sdbbp	1

	move	$a0, $s0

	.globl	__semihosting_close
	.type	__semihosting_close, @function
__semihosting_close:
	li	$t9, SEMIHOSTING_CLOSE
	sdbbp	1

	li	$a0, 0

	.globl	__semihosting_exit
	.type	__semihosting_exit, @function
__semihosting_exit:
	li	$t9, SEMIHOSTING_EXIT
	sdbbp	1

1:	j	1b
	nop

_buffer:
	.string	"MIPS sample 23456789012345678901"
