#!/bin/sh

LANG=C

date

. /home/user/server/files/param.sh

################################################################
# Cleaning

cd $homedir

rm -fR simple-inetd
rm -fR timer-exec
rm -fR cross-gcc494
rm -fR qemu
rm -fR $toolsdir

################################################################
# Make directory

cd $homedir

mkdir -p $archivedir
mkdir -p $toolsdir

################################################################
# Download tools

cd $homedir

if [ ! -f $archivedir/binutils-2.28.tar.bz2 ]; then
    cd $archivedir ; wget -q -nd http://www2.kozos.jp/tools/cross-gcc494/binutils-2.28.tar.bz2
fi
if [ ! -f $archivedir/gcc-4.9.4.tar.bz2 ]; then
    cd $archivedir ; wget -q -nd http://www2.kozos.jp/tools/cross-gcc494/gcc-4.9.4.tar.bz2
fi
if [ ! -f $archivedir/gdb-7.12.1.tar.gz ]; then
    cd $archivedir ; wget -q -nd http://www2.kozos.jp/tools/cross-gcc494/gdb-7.12.1.tar.gz
fi
if [ ! -f $archivedir/gmp-6.1.2.tar.bz2 ]; then
    cd $archivedir ; wget -q -nd http://www2.kozos.jp/tools/cross-gcc494/gmp-6.1.2.tar.bz2
fi
if [ ! -f $archivedir/mpc-1.0.3.tar.gz ]; then
    cd $archivedir ; wget -q -nd http://www2.kozos.jp/tools/cross-gcc494/mpc-1.0.3.tar.gz
fi
if [ ! -f $archivedir/mpfr-3.1.5.tar.bz2 ]; then
    cd $archivedir ; wget -q -nd http://www2.kozos.jp/tools/cross-gcc494/mpfr-3.1.5.tar.bz2
fi
if [ ! -f $archivedir/qemu-2.10.2.tar.xz ]; then
    cd $archivedir ; wget -q -nd http://www2.kozos.jp/tools/qemu/qemu-2.10.2.tar.xz
fi
if [ ! -f $archivedir/cross-gcc494-v1.0.zip ]; then
    cd $archivedir ; wget -q -nd http://kozos.jp/books/asm/cross-gcc494-v1.0.zip
fi
if [ ! -f $archivedir/pkttools-1.16.zip ]; then
    cd $archivedir ; wget -q -nd http://kozos.jp/software/pkttools-1.16.zip
fi

################################################################
# Build tools

cd $homedir

cp -R $serverdir/simple-inetd $homedir
cp -R $serverdir/timer-exec   $homedir
cd $homedir/simple-inetd ; make clean ; make
cd $homedir/timer-exec   ; make clean ; make

################################################################
# Build toolchain for reserve

cd $homedir

cp -R $serverdir/cross-gcc494 $homedir

# see ../sum.txt in fetch.sh
ln -s $archivedir $homedir/cross-gcc494/toolchain/orig
cp $homedir/cross-gcc494/toolchain/sum.txt $archivedir/..

# Setup

cd $homedir/cross-gcc494/toolchain ; ./fetch.sh ; ./setup.sh

# Build

cd $homedir/cross-gcc494/build ; ./setup-all.sh ; \
	./build-install-clean-all.sh arm-elf mips-elf aarch64-elf

################################################################
# Build QEMU

cd $homedir

mkdir -p qemu

# Setup

cd $homedir/qemu ; tar xvJf $archivedir/qemu-2.10.2.tar.xz

cd $homedir/qemu/qemu-2.10.2 ; patch -p0 < $serverdir/qemu/patch/qemu-2.10.2-target-arm-helper.c.patch
cd $homedir/qemu/qemu-2.10.2 ; patch -p0 < $serverdir/qemu/patch/qemu-2.10.2-target-mips-helper.c.patch
cd $homedir/qemu/qemu-2.10.2 ; patch -p0 < $serverdir/qemu/patch/qemu-2.10.2-for-freebsd.patch
cd $homedir/qemu/qemu-2.10.2 ; patch -p0 < $serverdir/qemu/patch/qemu-2.10.2-chardev-char-stdio.c.patch
# for disable system()
#cd $homedir/qemu/qemu-2.10.2 ; patch -p0 < $serverdir/qemu/patch/qemu-2.10.2-target-arm-arm-semi.c.patch

cd $homedir/qemu/qemu-2.10.2 ; ./configure --prefix=$qemudir \
	--target-list=arm-softmmu,aarch64-softmmu,mips-softmmu \
	--disable-docs --disable-gtk

# Build

cd $homedir/qemu/qemu-2.10.2 ; make ; make install

################################################################
# Shutdown

date

sudo /sbin/shutdown -h now
