#!/bin/sh

LANG=C

date

. /home/user/server/files/param.sh

################################################################
# Setting passwords

#passwd root
#passwd user

################################################################
# Setup keyboard

#localectl set-keymap jp106
#echo "KEYTABLE=jp106" >> /etc/default/keyboard
#echo "MODEL=jp106" >> /etc/default/keyboard
#echo "LAYOUT=jp" >> /etc/default/keyboard

################################################################
# Make users
# Not set password. If password is not set, the user cannot login.

cd $homedir

groupadd -g 10000 arch

for u in $allusers; do
    archparam $u
    useradd -u $uid -d /home/$user -g arch -c $user -m $user
#    chown root:wheel /home/$user
#    chmod 755 /home/$user
    mkdir /home/$user/bin
    mkdir /home/$user/lib
    mkdir /home/$user/dev
    mkdir -p /home/$user/home/user/tools/qemu
    mkdir /home/$user/tmp
    chmod 777 /home/$user/tmp
    touch /home/$user/tmp/.nodelete
    chattr +i /home/$user/tmp/.nodelete
done

################################################################
# Setup flag file

cd $homedir

echo "Team flags:" > /home/flag.txt
chmod 666 /home/flag.txt

for u in $users; do
    archparam $u
    if [ "$word" = yes ]; then
        printf "SECCON{" > /home/$user/word.txt
        cat $serverdir/attack-keyword.txt | grep ^$user: \
            | cut -d : -f 2 | perl -pe 's/\n//' >> /home/$user/word.txt
        printf "}\n" >> /home/$user/word.txt
    else
        echo "BAD LUCK NO KEYWORD" > /home/$user/word.txt
    fi
    chown $user:arch /home/$user/word.txt
    chattr +i /home/$user/word.txt
    ln /home/flag.txt /home/$user/flag.txt
done

chattr +a /home/flag.txt

################################################################
# Setup directory

cd $homedir

mkdir /home/lib
mkdir /home/bin
mkdir /home/bin/qemu
mkdir /home/bin/exec

#cp /bin/sh /home/bin
#cp /bin/sleep /home/bin

cp /lib/ld-linux.so.* /home/lib
#cp /lib/linux-gate.so.* /home/lib

cp /lib/i386-linux-gnu/libz.so.* /home/lib
cp /usr/lib/i386-linux-gnu/libpixman-1.so.* /home/lib
cp /lib/i386-linux-gnu/libutil.so.* /home/lib
cp /usr/lib/i386-linux-gnu/libgthread-2.0.so.* /home/lib
cp /lib/i386-linux-gnu/libglib-2.0.so.* /home/lib
cp /lib/i386-linux-gnu/librt.so.* /home/lib
cp /usr/lib/i386-linux-gnu/libstdc++.so.* /home/lib
cp /lib/i386-linux-gnu/libm.so.* /home/lib
cp /lib/i386-linux-gnu/libgcc_s.so.* /home/lib
cp /lib/i386-linux-gnu/libpthread.so.* /home/lib
cp /lib/i386-linux-gnu/libc.so.* /home/lib
cp /lib/i386-linux-gnu/libpcre.so.* /home/lib

cp $serverdir/exec/*.x /home/bin/exec

mkdir /home/dev
mknod -m 644 /home/dev/urandom c 1 9

mkdir /home/qemu
cp -R /home/user/tools/qemu/* /home/qemu

################################################################
# Setup QEMU

cd $homedir

cp $toolsdir/qemu/bin/qemu-system-* /home/bin/qemu

################################################################
# Fix files

cd $homedir

chattr -R +i /home/bin /home/lib /home/dev /home/qemu

################################################################
# Setup iptables

cd $homedir

export DEBIAN_FRONTEND=noninteractive
export APT_LISTCHANGES_FRONTEND=none

yes | apt-get -y install iptables
yes | apt-get -y install iptables-persistent

mv /etc/iptables/rules.v4 /etc/iptables/rules.v4.orig
echo "*filter" > /etc/iptables/rules.v4

echo "-A INPUT -m state --state ESTABLISHED,RELATED -j ACCEPT" >> /etc/iptables/rules.v4
echo "-A INPUT -p icmp -j ACCEPT" >> /etc/iptables/rules.v4
echo "-A INPUT -i lo -j ACCEPT" >> /etc/iptables/rules.v4

echo "-A INPUT -m state --state NEW -m tcp -p tcp --dport 22 -j ACCEPT" \
    >> /etc/iptables/rules.v4
#echo "-A INPUT -m state --state NEW -m tcp -p tcp --dport 80 -j ACCEPT" \
#    >> /etc/iptables/rules.v4
echo "-A INPUT -m state --state NEW -m hashlimit -p tcp --dport 80 --hashlimit-name http --hashlimit 1/s --hashlimit-burst 10 --hashlimit-mode srcip --hashlimit-srcmask 24 --hashlimit-htable-expire 10000 -j ACCEPT" \
    >> /etc/iptables/rules.v4

#echo "-A INPUT -m state --state NEW -m tcp -p tcp --dport 12345 -j ACCEPT" \
#    >> /etc/iptables/rules.v4

for u in $allusers; do
    archparam $u
#    echo "-A INPUT -m state --state NEW -m tcp -p tcp --dport $port -j ACCEPT" \
#        >> /etc/iptables/rules.v4
    echo "-A INPUT -m state --state NEW -m hashlimit -p tcp --dport $port --hashlimit-name port$port --hashlimit 1/s --hashlimit-burst 3 --hashlimit-mode srcip --hashlimit-srcmask 24 --hashlimit-htable-expire 10000 -j ACCEPT" \
        >> /etc/iptables/rules.v4
done

echo "-A INPUT -j REJECT --reject-with icmp-host-prohibited" \
    >> /etc/iptables/rules.v4
echo "-A FORWARD -j REJECT --reject-with icmp-host-prohibited" \
    >> /etc/iptables/rules.v4

echo "-A INPUT -j REJECT" >> /etc/iptables/rules.v4
echo "-A FORWARD -j REJECT" >> /etc/iptables/rules.v4
echo "-A OUTPUT -j ACCEPT" >> /etc/iptables/rules.v4

echo COMMIT >> /etc/iptables/rules.v4

################################################################
# Setup SSH

cd $homedir

yes | apt-get -y install openssh-server

cp /etc/ssh/sshd_config /etc/ssh/sshd_config.orig
cat /etc/ssh/sshd_config.orig \
    | $tocomment - - 0 0 "#" ^PermitRootLogin \
    | $tocomment - - 0 0 "#" ^PasswordAuthentication \
    | $tocomment - - 0 0 "#" ^PermitEmptyPasswords \
    | $tocomment - - 0 0 "#" ^ChallengeResponseAuthentication \
    > /etc/ssh/sshd_config
echo "PermitRootLogin no" >> /etc/ssh/sshd_config
echo "PasswordAuthentication no" >> /etc/ssh/sshd_config
echo "PermitEmptyPasswords no" >> /etc/ssh/sshd_config
echo "ChallengeResponseAuthentication yes" >> /etc/ssh/sshd_config
echo "AllowUsers user" >> /etc/ssh/sshd_config

################################################################
# Setup httpd

cd $homedir

yes | apt-get -y install apache2

cp $serverdir/files/index.html /var/www/html

cp $serverdir/exec/*.x /var/www/html

cp $archivedir/binutils-2.28.tar.bz2 /var/www/html
cp $archivedir/gcc-4.9.4.tar.bz2 /var/www/html
cp $archivedir/gdb-7.12.1.tar.gz /var/www/html
cp $archivedir/gmp-6.1.2.tar.bz2 /var/www/html
cp $archivedir/mpfr-3.1.5.tar.bz2 /var/www/html
cp $archivedir/mpc-1.0.3.tar.gz /var/www/html
cp $archivedir/cross-gcc494-v1.0.zip /var/www/html
cp $archivedir/qemu-2.10.2.tar.xz /var/www/html

################################################################
# Setup boot

cd $homedir

cp /etc/rc.local /etc/rc.local.orig
cat /etc/rc.local.orig \
    | $tocomment - - 0 0 "#" ^exit \
    > /etc/rc.local
echo "/home/user/server/files/mount.sh" >> /etc/rc.local
echo "/home/user/server/files/run.sh &" >> /etc/rc.local
echo "exit 0" >> /etc/rc.local

################################################################
# Shutdown

date

/sbin/shutdown -h now
