#!/bin/sh

homedir=/home/user
serverdir=$homedir/server
archivedir=$homedir/archive

# install directories
toolsdir=$homedir/tools
crossdir=$toolsdir/cross-gcc494
qemudir=$toolsdir/qemu

tocomment=$serverdir/files/tocomment.pl

archs=""

# Enable architectures
archs="$archs ARM:arm-elf:cross-gcc494:yes:enable"
archs="$archs MIPS:mips-elf:cross-gcc494:yes:enable"
archs="$archs AArch64:aarch64-elf:cross-gcc494:yes:enable"

# Optional architectures (not supported)
archs="$archs Thumb:arm16-elf:cross-gcc494:no:disable"
archs="$archs MIPS16:mips16-elf:cross-gcc494:no:disable"

archparam()
{
    user=`echo $1 | cut -d : -f 1`
    uid=`echo $1 | cut -d : -f 2`
    port=`echo $1 | cut -d : -f 3`
    name=`echo $1 | cut -d : -f 4`
    arch=`echo $1 | cut -d : -f 5`
    path=`echo $1 | cut -d : -f 6`
    word=`echo $1 | cut -d : -f 7`
    enable=`echo $1 | cut -d : -f 8`
}

allusers=""
alluserlist=""
n=0
for a in $archs; do
    user=`printf arch%02d $n`
    uid=`expr $n + 10000`
    port=`expr $n + 10000`
    allusers="$allusers $user:$uid:$port"
    alluserlist="$alluserlist $user"
    n=`expr $n + 1`
done

users=""
userlist=""
n=0
for a in $archs; do
    enable=`echo $a | cut -d : -f 5`
    if [ "$enable" = "enable" ]; then
	user=`printf arch%02d $n`
	uid=`expr $n + 10000`
	port=`expr $n + 10000`
	users="$users $user:$uid:$port:$a"
	userlist="$userlist $user"
	n=`expr $n + 1`
    fi
done
