#!/bin/sh

. /home/user/server/files/param.sh

inetd=$homedir/simple-inetd/simple-inetd
timerdir=$homedir/timer-exec
timer=timer-exec
startport=10000
gid=10000
limit=5

/home/user/server/files/check.pl /tmp/simple-inetd.log 3 $startport /home/flag.txt &
/home/user/server/files/update.pl 3 /tmp/size.txt 1024 /var/www/html/flag.txt /home/flag.txt &

for u in $users; do
    archparam $u

    cmd=
    opt=
    case $arch in
	arm-elf)
	    cmd="qemu-system-arm"
	    opt="-machine raspi2 -m 128"
	    ;;
	mips-elf)
	    cmd="qemu-system-mips"
	    opt="-machine mipssim -m 128"
	    ;;
	aarch64-elf)
	    cmd="qemu-system-aarch64"
	    opt="-machine virt -cpu cortex-a57 -m 1280"
	    ;;
    esac
    opt="$opt -nographic -monitor none -semihosting-config enable=on,target=native"
    opt="$opt -singlestep"

    $inetd any $port 0 0 $timerdir $timer \
	$timer $limit 9 $uid $gid /home/$user /bin/qemu/$cmd \
	$cmd $opt -kernel /bin/exec/$arch.x &
done
