/*
 * for special system call by special patch to QEMU
 */

#define SPECIAL_SYSCALL_READC  1
#define SPECIAL_SYSCALL_WRITEC 2
#define SPECIAL_SYSCALL_EXIT   (0x80 + 1)
#define SPECIAL_SYSCALL_OPEN   (0x80 + 3)
#define SPECIAL_SYSCALL_READ   (0x80 + 4)
#define SPECIAL_SYSCALL_WRITE  (0x80 + 5)
#define SPECIAL_SYSCALL_CLOSE  (0x80 + 6)

	.section .text

	.globl	_start
	.type	_start, @function
_start:
	lui	$sp, %hi(_estack)
	addiu	$sp, $sp, %lo(_estack)
	lui	$gp, %hi(_gp)
	addiu	$gp, $gp, %lo(_gp)
	jal	main
	nop

	move	$a0, $v0
	/* fall through */

#ifdef SYSCALL_WRAPPER_ALL
	.globl	__exit
	.type	__exit, @function
__exit:
	li	$v0, SPECIAL_SYSCALL_EXIT
	syscall
	jr	$ra
	nop
#else
	jal	__semihosting_exit
	nop
1:	j	1b
	nop
#endif

	.globl	__readc
	.type	__readc, @function
__readc:
	li	$v0, SPECIAL_SYSCALL_READC
	syscall
	jr	$ra
	nop

	.globl	__writec
	.type	__writec, @function
__writec:
	li	$v0, SPECIAL_SYSCALL_WRITEC
	syscall
	jr	$ra
	nop

#ifdef SYSCALL_WRAPPER_ALL
	.globl	__read
	.type	__read, @function
__read:
	li	$v0, SPECIAL_SYSCALL_READ
	syscall
	jr	$ra
	nop

	.globl	__write
	.type	__write, @function
__write:
	li	$v0, SPECIAL_SYSCALL_WRITE
	syscall
	jr	$ra
	nop

	.globl	__open
	.type	__open, @function
__open:
	li	$v0, SPECIAL_SYSCALL_OPEN
	syscall
	jr	$ra
	nop

	.globl	__close
	.type	__close, @function
__close:
	li	$v0, SPECIAL_SYSCALL_CLOSE
	syscall
	jr	$ra
	nop
#endif

/*
 * for semihosting call on QEMU
 */

#define SEMIHOSTING_EXIT  1
#define SEMIHOSTING_OPEN  2
#define SEMIHOSTING_CLOSE 3
#define SEMIHOSTING_READ  4
#define SEMIHOSTING_WRITE 5

	.globl	__semihosting_exit
	.type	__semihosting_exit, @function
__semihosting_exit:
	li	$t9, SEMIHOSTING_EXIT
	sdbbp	1
	jr	$ra
	nop

#ifdef SYSCALL_WRAPPER_ALL
	.globl	__semihosting_open
	.type	__semihosting_open, @function
__semihosting_open:
	li	$t9, SEMIHOSTING_OPEN
	sdbbp	1
	jr	$ra
	nop

	.globl	__semihosting_close
	.type	__semihosting_close, @function
__semihosting_close:
	li	$t9, SEMIHOSTING_CLOSE
	sdbbp	1
	jr	$ra
	nop

	.globl	__semihosting_read
	.type	__semihosting_read, @function
__semihosting_read:
	li	$t9, SEMIHOSTING_READ
	sdbbp	1
	jr	$ra
	nop

	.globl	__semihosting_write
	.type	__semihosting_write, @function
__semihosting_write:
	li	$t9, SEMIHOSTING_WRITE
	sdbbp	1
	jr	$ra
	nop
#endif
